 2/20/86

     IBM PROVIDES THE FOLLOWING PATCH FOR DOS 3.0 AND DOS 3.1 
  -------------------------------------------------------------------

   DESCRIPTION: This patch corrects a condition where DOS is doing a 
   test on bit 8 to determine if an error code returned from INT 13h   
   should fall into the DMA boundary violation handler. This test is 
   causing error codes other than DMA (09h) to fall into this handler. 
   The patch changes this test to a direct compare.

   The patch corrects the same problem with each version of DOS 3.
  ____________________________________________________________________


The patch is made to the System file IBMBIO.COM. 

NOTE: The safest method of doing this is given in the last paragraph
of this document. However, for those who feel sufficiently competant,
and who don't wish to follow that course, the following method is 
presented.

It will first be necessary to remove the Hidden/System/Read-only 
attribute, thus making the file a 'normal' file. AFTER you have 
completed the patch process, you MUST RESET this attribute to 
Hidden/System/Read-only.

To work with the attibute, you can use the PD program CHMOD, or the 
Norton Utility Ver 3.1's FA.COM, Morgan Computing's DISKTOOL, or IBM's 
DISK REPAIR, a part of the PROFESSIONAL DEBUG package. You cannot use
the DOS utility ATTRIB.COM. 

(Just for information, a 'normal' file attibute is either 00h or 20h, 
while a Hidden/System/Read-only attribute is either 07h or 27h. The
attribute is one byte and is located in the Directory entry for the
file, immediately following the last character in the filename 
extension. In this case, after the 'M' in COM.)  

See the documentation for whichever program above you've chosen to
determine the procedure to be used.

                      *   *   *   *   *   *   *


NOTE: YOU ARE PATCHING THE HEART OF THE OPERATING SYSTEM... BE VERY
      CAREFUL!!!  IF YOU THINK YOU MAY HAVE MADE A MISTAKE, EXIT 
      BEFORE WRITING THE CHANGES AND START OVER AGAIN. 

Format a floppy using the command, FORMAT /S. Set the attribute for
IBMBIO.COM to 'normal' as given above.

Use the DOS utility DEBUG.COM, (or MicroSoft's SYMDEB), to make this 
patch. It is assumed that you are familiar with its use.

Curiously, the patch changes only 4 bytes, though IBM indicates a 
5-byte patch.

-------------------------------------------------------------------

PATCH NUMBER: PATCH31.001

Use this patch if you have DOS 3.1:

DOS LEVEL: 3.10

FILE PATCHED: IBMBIO.COM

OFFSET OF PATCH: 09BB   (Note: DEBUG address = 0ABB)

NUMBER OF BYTES: 5

OLD CODE: F6 C4 08 75 0F

NEW CODE: 80 FC 09 74 0F


In what follows, Do not type the hyphens. The 'xxxx' mean 'don't care'.
At the DOS prompt type: 

    DEBUG d:\IBMBIO.COM <cr>    where d: = drive containing IBMBIO.COM
    -D 0ABB L5 <cr>
    xxxx:0AB0     You should see OLD CODE given above starting at 0ABB. 

    -E 0ABB  80 FC 09 74 0F <cr>
    -D 0ABB L5 <cr>
    xxxx:0AB0     You should see NEW CODE given above starting at 0ABB.

    -W <cr>
    Writing xxxx bytes
    -Q <cr>

 Patching complete. Reset the attribute to Hidden/System/Read-only.
 (At this point, you should consider bringing up the file again and
 and doing -D 0ABB L5, just as a final check).

----------------------------------------------------------------------

PATCH NUMBER: PATCH30.001

Use this patch if you have DOS 3.0

DOS LEVEL: 3.00

FILE PATCHED: IBMBIO.COM

OFFSET OF PATCH: 0964   (Note: DEBUG address = 0A64)

NUMBER OF BYTES: 5

OLD CODE: F6 C4 08 75 04

NEW CODE: 80 FC 09 74 04

In what follows, Do not type the hyphens. The 'xxxx' mean 'don't care'.
At the DOS prompt type: 

    DEBUG d:\IBMBIO.COM <cr>    where d: = drive containing IBMBIO.COM
    -D 0A64 L5 <cr>
    xxxx:0A60     You should see OLD CODE given above starting at 0A64. 

    -E 0A64  80 FC 09 74 04 <cr>
    -D 0A64 L5 <cr>
    xxxx:0A60     You should see NEW CODE given above starting at 0A64.

    -W <cr>
    Writing xxxx bytes
    -Q <cr>

 Patching complete. Reset the attribute to Hidden/System/Read-only.
 (At this point, you should consider bringing up the file again and
 and doing -D 0A64 L5, just as a final check.) 

--------------------------------------------------------------------------


TO UPDATE IBMBIO.COM ON YOUR HARD DISK:

    IMPORTANT!!! DO NOT USE DEBUG TO PATCH IBMBIO.COM ON A HARD DISK.

1.  Complete the above, creating a floppy with the patched 
    IBMBIO.COM, with attibute reset to Hid/Sys/Read-only.  Then:  Copy 
    the DOS utility SYS.COM onto the floppy. Set the default drive to A: 
    and put the floppy in it. Then type SYS C:<cr> (assuming your HD is
    Drive C:). You should then see the message 'system transferred'.

    YOU CANNOT SIMPLY USE DEBUG TO PATCH AN IBMBIO.COM THAT RESIDES ON A
    HARD DISK, BECAUSE DEBUG WILL NOT WRITE THE FILE BACK TO THE SAME
    SPACE ON A HARD DISK.  IBMBIO.COM MUST RESIDE IN A SPECIFIC PLACE ON 
    A DISK, and while DEBUG will write it back to the same place it came 
    from on a floppy, it will not do so on a hard disk.

                          *   *   *   *

If you're patching a hard disk and have a problem, you can always put
your DOS System disk in Drive A:, boot it, and type SYS C:<cr>, which
will replace the system files on the HD, provided of course that you
haven't written anything to the hard disk before doing this.

If you are not familiar with DEBUG, or simply don't want to monkey with 
it, then you may obtain the DOS 3 Patch Disk No. 1, from your dealer at 
no charge, (ask them to get it from Dealer Support if they don't have it).
That disk contains an IBM program PATCH.COM, which will make the patch 
automatically.  Since that program is not PD, we cannot post it.

